	/* ------------------------------------------------------------ */
	/* RSA Encryption Algorithm	                                    */
	/* Version: 1.0.0       	                                    */
	/*                                                              */
	/* Copyright Michael Sibbons. All Rights Reserved.              */
	/* E: michael@sibbons.net	                                    */
	/* ------------------------------------------------------------ */
	
using System;

class main
{

    //declare the variables
    double p = 0;
    double q = 0;
    double n = 0;
    //double r = 0;
    double e = 0;
    double d = 0;

    public static void Main()
    {
        string menuChoice;

        //declare the class
        main m = new main();

        

        do
        {
            // show menu and get input from user
            menuChoice = m.mainMenu();

            // Make a decision based on the user's choice
            m.makeMenuChoice(menuChoice);

        } while (menuChoice != "Q"); // Keep going until the user wants to quit
    }

    // show menu and get user's choice
    private string mainMenu()
    {
        string choice;

        // Print A Menu
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        //Console.WriteLine("PA - Create Key Pair");
        Console.WriteLine("PU - Public Key Config");
        Console.WriteLine("PR - Private Key Config");
        if(e > 0) Console.WriteLine("E - Encrypt");
        if(d > 0) Console.WriteLine("D - Decrypt");
        Console.WriteLine("Q - Quit\n");

        Console.Write("Choice (PU, PR");
        if(e > 0) Console.Write(", E");
        if (d > 0) Console.Write(", D");
        Console.WriteLine(" or Q): ");

        // Retrieve the user's choice
        choice = Console.ReadLine();

        return choice;
    }

    // make decision
    void makeMenuChoice(string menuChoice)
    {
     
        switch (menuChoice)
        {
            case "PA":
                break;

            case "PU":
                pu_menu();
                break;

            case "PR":
                pr_menu();
                break;

            case "E":
                encrypt();
                break;

            case "D":
                decrypt();
                break;

        }
    }

    //pu menu
    void pu_menu()
    {
        string choice;

        
        do
        {
            Console.Clear();
            Console.WriteLine("RSA Encryption Generator\n");

            Console.WriteLine("C - Create Public Key");
            Console.WriteLine("I - Insert Public Key");
            if (e > 0 && n > 0) Console.WriteLine("V - View Public Key");
            Console.WriteLine("B - Back\n");

            Console.Write("Choice (C, I");
            if (e > 0 && n > 0) Console.Write(", V");
            Console.WriteLine(", B):");

            choice = Console.ReadLine();

            switch (choice)
            {
                case "C":
                    pu_create();
                    break;

                case "I":
                    pu_insert();
                    break;

                case "V":
                    pu_view();
                    break;


            }

        } while (choice != "B"); // Keep going until the user wants to quit
    }


    //create public key
    void pu_create()
    {
        //temporary variable used for converting strings to double
        string temp;

        //get e
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Please enter the encryption exponent:");
        temp = Console.ReadLine();
        e = Convert.ToDouble(temp);

        //get p
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Please enter the p value:");
        temp = Console.ReadLine();
        p = Convert.ToDouble(temp);

        //get q
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Please enter the q value:");
        temp = Console.ReadLine();
        q = Convert.ToDouble(temp);

        //create n
        n = p * q;

        //output public key
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Your Public key is PU({0},{1})\n",e,n);
        Console.WriteLine("Press enter to continue");
        Console.ReadLine();

        return;
    }


    //insert public key
    void pu_insert()
    {
        //temporary variable used for converting strings to double
        string temp;

        //get e
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Please enter the encryption exponent:");
        temp = Console.ReadLine();
        e = Convert.ToDouble(temp);

        //get n
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Please enter the n value:");
        temp = Console.ReadLine();
        n = Convert.ToDouble(temp);

        //output public key
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Your Public key is PU({0},{1})\n", e, n);
        Console.WriteLine("Press enter to continue");
        Console.ReadLine();

        return;
    }


    //view public key
    void pu_view()
    {

        //output public key
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Your Public key is PU({0},{1})\n", e, n);
        Console.WriteLine("Press enter to continue");
        Console.ReadLine();

        return;
    }

    //pu menu
    void pr_menu()
    {
        string choice;


        do
        {
            Console.Clear();
            Console.WriteLine("RSA Encryption Generator\n");

            Console.WriteLine("C - Create Private Key");
            Console.WriteLine("I - Insert Private Key");
            if (d > 0 && p > 0 && q > 0) Console.WriteLine("V - View Private Key");
            Console.WriteLine("B - Back\n");

            Console.Write("Choice (C, I");
            if (d > 0 && p > 0 && q > 0) Console.Write(", V");
            Console.WriteLine(", B):");

            choice = Console.ReadLine();

            switch (choice)
            {
                case "C":
                    pr_create();
                    break;

                case "I":
                    pr_insert();
                    break;

                case "V":
                    pr_view();
                    break;


            }

        } while (choice != "B"); // Keep going until the user wants to quit
    }


    //create public key
    void pr_create()
    {
        //temporary variable used for converting strings to double
        string temp;

        //get e
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Please enter the decryption exponent:");
        temp = Console.ReadLine();
        d = Convert.ToDouble(temp);

        //get p
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Please enter the p value:");
        temp = Console.ReadLine();
        p = Convert.ToDouble(temp);

        //get q
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Please enter the q value:");
        temp = Console.ReadLine();
        q = Convert.ToDouble(temp);

        //create n
        n = p * q;

        //output private key
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Your Private key is PR({0},{1},{2})\n", d, p, q);
        Console.WriteLine("Press enter to continue");
        Console.ReadLine();

        return;
    }


    //insert public key
    void pr_insert()
    {
        //temporary variable used for converting strings to double
        string temp;

        //get d
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Please enter the decryption exponent:");
        temp = Console.ReadLine();
        d = Convert.ToDouble(temp);

        //get p
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Please enter the p value:");
        temp = Console.ReadLine();
        p = Convert.ToDouble(temp);

        //get q
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Please enter the q value:");
        temp = Console.ReadLine();
        q = Convert.ToDouble(temp);
        
        //output private key
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Your Private key is PR({0},{1},{2})\n", d, p, q);
        Console.WriteLine("Press enter to continue");
        Console.ReadLine();

        return;
    }


    //view public key
    void pr_view()
    {

        //output private key
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Your Private key is PR({0},{1},{2})\n", d, p, q);
        Console.WriteLine("Press enter to continue");
        Console.ReadLine();

        return;
    }


    //encrypt
    void encrypt()
    {
        //temporary variable used for storing string to convert to double
        string temp;

        double m;
        double c; 

        //output public key
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Please enter the number you wish to encrypt:");
        temp = Console.ReadLine();
        m = Convert.ToDouble(temp);

        //encrypt
        c = Math.Pow(m, e);
        c = c % n;

        //output ciphertext
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("The ciphertext of {0} is {1}\n", m, c);
        Console.WriteLine("Press enter to continue");
        Console.ReadLine();

        return;
    }


    //decrypt
    void decrypt()
    {
        //temporary variable used for storing string to convert to double
        string temp;

        double m;
        double c;

        //output public key
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("Please enter the number you wish to decrypt:");
        temp = Console.ReadLine();
        c = Convert.ToDouble(temp);

        //encrypt
        m = Math.Pow(c, d);
        m = m % n;

        //output ciphertext
        Console.Clear();
        Console.WriteLine("RSA Encryption Generator\n");

        Console.WriteLine("The plain text of {0} is {1}\n", c, m);
        Console.WriteLine("Press enter to continue");
        Console.ReadLine();

        return;
    }

    
}